Attribute VB_Name = "OpenIDW"
Option Explicit
Dim osize_str As String
Dim osheet_str As Integer
Dim oorient As Integer
Dim oIDW As DrawingDocument
Dim oDoc As Document
Dim osheet As Sheet
Dim opoint As Point2d
Dim oTG As Inventor.TransientGeometry
Dim oview As DrawingView
Dim oview2 As DrawingView
Dim oinsdoc As Document
Dim fs As Object
Dim odocname As String
Dim pfad As String
Dim dateiname As String
Dim temp_str As String
Dim opointx As Single
Dim opointy As Single

Public Sub OpenIDW()

temp_str = "D:\Inventor\Templates\Norm.idw"
    
Dim oFS As New Scripting.FileSystemObject
If oFS.FileExists(temp_str) = False Then
    MsgBox "Die angegebene Zeichnungsvorlage kann nciht gefunden werden!"
    End
End If

Set oDoc = ThisApplication.ActiveDocument

odocname = oDoc.FullFileName
If odocname = "" Then
MsgBox "Bitte Modell erst speichern!"
Exit Sub
End If
pfad = VBA.Left(oDoc.FullFileName, InStrRev(odocname, "\"))
dateiname = VBA.Mid(odocname, InStrRev(odocname, "\") + 1)
dateiname = VBA.Left(dateiname, Len(dateiname) - 4)
dateiname = pfad & dateiname & ".idw"

Set fs = CreateObject("Scripting.FileSystemObject")

If fs.FileExists(dateiname) = True Then
ThisApplication.Documents.Open (dateiname)
Else: Call CreateIDW
End If
End Sub

Function CreateIDW()

Set oDoc = ThisApplication.ActiveDocument

If oDoc.Type <> kDrawingDocumentObject Then

Call osize

frmIDW.Show

End If

End Function

Function osize()
    
If frmIDW.optA4 = True Then
    osize_str = frmIDW.optA4.Caption
    osheet_str = 9997
    oorient = 10243
End If

If frmIDW.optA3 = True Then
    osize_str = frmIDW.optA3.Caption
    osheet_str = 9996
    oorient = 10242
End If

If frmIDW.optA2 = True Then
    osize_str = frmIDW.optA2.Caption
    osheet_str = 9995
    oorient = 10243
End If

End Function

Function oViewAdd()

Set oIDW = ThisApplication.Documents.Add(kDrawingDocumentObject, temp_str)

Dim oopt As Control
Dim ostab As Double
Dim ostyle As Long

For Each oopt In frmIDW.Frame_mastab.Controls

If oopt.Value = True Then
ostab = Val(oopt.Tag)
End If

Next oopt

For Each oopt In frmIDW.Frame_Style.Controls

If oopt.Value = True Then
ostyle = Val(oopt.Tag)
Exit For
Else: ostyle = frmIDW.Frame_Style.optVis.Tag

End If

Next oopt

Set osheet = oIDW.ActiveSheet

osheet.Size = osheet_str
osheet.Orientation = oorient

On Error Resume Next
osheet.Border.Delete

Dim oBorder As BorderDefinition
For Each oBorder In oIDW.BorderDefinitions
    If InStr(oBorder.Name, osize_str) <> 0 Then
        osize_str = oBorder.Name
    End If
Next

osheet.AddBorder (osize_str)
On Error GoTo 0

Set oTG = ThisApplication.TransientGeometry

opointx = osheet.Width / 2
opointy = osheet.height / 2

Set opoint = oTG.CreatePoint2d(opointx, opointy)

Set oview = osheet.DrawingViews.AddBaseView(oDoc, opoint, ostab, kCurrentViewOrientation, ostyle)

If frmIDW.but_li.Value = True Then

Set opoint = oTG.CreatePoint2d(opointx - opointx * 0.9, opointy)
Set oview2 = osheet.DrawingViews.AddProjectedView(oview, opoint, ostyle)

End If

If frmIDW.but_re.Value = True Then

Set opoint = oTG.CreatePoint2d(opointx + opointx * 0.9, opointy)
Set oview2 = osheet.DrawingViews.AddProjectedView(oview, opoint, ostyle)

End If

If frmIDW.but_ob.Value = True Then

Set opoint = oTG.CreatePoint2d(opointx, opointy + opointy * 0.9)
Set oview2 = osheet.DrawingViews.AddProjectedView(oview, opoint, ostyle)

End If

If frmIDW.but_un.Value = True Then

Set opoint = oTG.CreatePoint2d(opointx, opointy - opointy * 0.9)
Set oview2 = osheet.DrawingViews.AddProjectedView(oview, opoint, ostyle)

End If

If frmIDW.but_iso.Value = True Then

Set opoint = oTG.CreatePoint2d(opointx / 5, opointy / 5)
Set oview2 = osheet.DrawingViews.AddProjectedView(oview, opoint, kShadedDrawingViewStyle, ostab / 2)
oview2.Name = "ISO"

End If

End Function

